<template>
  <v-menu
    :close-on-content-click="false"
    :model-value="true"
  >
    <template #activator="{ props }">
      <!-- Filter chip (which activates the menu) -->
      <div
        v-bind="props"
        class="flex justify-center items-center gap-2 px-2 py-[6px] border border-primary rounded-[8px]
          cursor-pointer max-w-full sm:max-w-[300px]"
        :class="selectedFilterAnswerData?.length ? 'border-primary' : 'border-darkGrey'"
      >
        <!-- Filter chip main content -->
        <div class="flex items-center gap-1">
          <!-- Filter Chip Icon -->
          <div v-if="item?.icon">
            <Icon
              :icon="item?.icon"
              height="16"
              width="16"
              :class="selectedFilterAnswerData?.length ? 'text-primary' : 'text-darkGrey'"
            />
          </div>

          <!-- Filter Chip title -->
          <p
            class="text-xs"
            :class="selectedFilterAnswerData?.length ? 'text-primary font-medium' : 'text-darkGrey font-normal'"
          >
            {{ item?.title }} :
          </p>

          <!-- Filter Chip Operator Option & Answer -->
          <div
            v-if="selectedFilterAnswerData?.length"
            class="flex items-center gap-1"
          >
            <!-- Filter Chip Selected Operator Option -->
            <p
              v-if="item?.type === 'number' || item?.type === 'date'"
              class="text-xs text-primary font-normal capitalize"
            >
              {{ filterOperatorOption }}
            </p>

            <!-- Filter Chip Selected Answer(s) (Type multi_select) -->
            <div
              v-if="item?.type === 'multi_select'"
              class="max-w-[115px] flex items-center gap-1"
            >
              <p
                class="text-xs text-primary font-normal truncate"
              >
                {{ getFilterAnswers() }}
              </p>
            </div>

            <!-- Filter Chip Selected Answer(s) (Other types) -->
            <div
              v-else
              class="max-w-[115px]"
            >
              <p class="text-xs text-primary font-normal truncate">
                {{ selectedFilterAnswerData }}
              </p>
            </div>
          </div>
        </div>

        <!-- Down arrow at the end of the filter chip -->
        <div @click="selectedFilterAnswerData?.length ? '' : deleteFilter()">
          <Icon
            :icon="selectedFilterAnswerData?.length ? 'material-symbols:keyboard-arrow-down' : 'material-symbols:close'"
            height="16"
            width="16"
            :class="selectedFilterAnswerData?.length ? 'text-primary' : 'text-darkGrey hover:!text-fake-black'"
          />
        </div>
      </div>
    </template>

    <!-- Filter chip menu (after the chip is pressed) -->
    <v-list class="!py-0">
      <div class="flex flex-col p-4 items-start gap-2 w-full min-w-[227px] max-w-[500px]">
        <div class="w-full gap-10 flex items-center">
          <div class="w-full flex items-center gap-4">
            <!-- Filter chip title -->
            <p class="text-darkGrey text-xs font-normal">
              {{ item?.title }}
            </p>

            <!-- Filter chip selected operator option (Type text && multi_select) -->
            <p
              v-if="item?.type === 'text' || item?.type === 'multi_select'"
              class="text-darkGrey text-xs font-medium"
            >
              {{ "contains" }}
            </p>

            <!-- Filter chip selected operator option (Other types) -->
            <v-menu
              v-else
              :close-on-content-click="false"
            >
              <template #activator="{ props }">
                <!-- Menu activator to select another filter operator option -->
                <div
                  id="activatorMenu"
                  v-bind="props"
                  class="flex items-center cursor-pointer gap-1"
                >
                  <!-- Filter Chip selected operator option -->
                  <p class="text-darkGrey text-sm font-normal line-clamp-1 capitalize">
                    {{ filterOperatorOption }}
                  </p>

                  <!-- Down arrow after filter operator option -->
                  <div v-if="item?.type !== 'text' && item?.type !== 'multi_select'">
                    <Icon
                      icon="material-symbols:keyboard-arrow-down"
                      height="16"
                      width="16"
                      class="text-darkGrey"
                    />
                  </div>
                </div>
              </template>

              <!-- Filter operator option list -->
              <v-list class="!py-0">
                <div
                  v-for="(element, index) in getSelectItemsAccordingToType(item?.type)"
                  :key="index"
                  class="flex items-center gap-2 flex-1 cursor-pointer py-3 px-2 hover:bg-light-grey min-w-[167px]"
                  @click="changeSelectItemModel(element)"
                >
                  <!-- Icon for the filter operator option if the filter's type is number -->
                  <div v-if="new Set(['equals', 'not_equal', 'greater_than', 'less_than']).has(element)">
                    <Icon
                      :icon="getSelectItemIcon(element)"
                      height="16"
                      width="16"
                      class="text-fakeBlack"
                    />
                  </div>

                  <!-- Filter operator option value -->
                  <p class="text-fakeBlack text-sm font-normal line-clamp-1">
                    {{ getSelectItemText(element) }}
                  </p>
                </div>
              </v-list>
            </v-menu>
          </div>

          <!-- Delete filter Button -->
          <div
            class="cursor-pointer"
            @click="deleteFilter"
          >
            <Icon
              icon="mdi:trash-can-outline"
              height="16"
              width="16"
              class="text-negativeRed"
            />
          </div>
        </div>

        <!-- Filter type="text" OR Filter type="number" -->
        <v-text-field
          v-if="item?.type === 'text' || item?.type === 'number'"
          v-model="selectedFilterAnswerData"
          :label="`${item?.title}`"
          hide-details
          :type="item?.type"
          variant="outlined"
          density="compact"
          class="w-full text-xs font-normal"
          @update:model-value="updateSelectedFilterAnswerData"  
        />

        <!-- Filter type="date" -->
        <svn-date-picker
          v-else-if="item?.type === 'date'"
          v-model="selectedFilterAnswerData"
          base-color="primary"
          density="compact"
          class="!w-full"
          @update:model-value="updateSelectedFilterAnswerData"
        />

        <!-- Filter type="multi_select" -->
        <v-autocomplete
          v-else-if="item?.type === 'multi_select'"
          v-model="selectedFilterAnswerData"
          v-model:search="searchText"
          variant="outlined"
          chips
          multiple
          density="compact"
          class="w-full"
          hide-details
          :item-title="(item) => { return `${item}`}"
          item-value="key"
          :items="formattedFilteredData"
          :placeholder="'Search'"
          @update:search="searchText = $event"
          @input="setSearch"
          @update:model-value="updateSelectedFilterAnswerData"
        >
          <template #no-data>
            <div
              class="w-full h-full flex flex-col justify-center items-center px-4 py-20 mx-auto"
            >
              <v-list-item-title>
                {{ ('No result found, please try again !') }}
              </v-list-item-title>
            </div>
          </template>
        </v-autocomplete>
      </div>
    </v-list>
  </v-menu>
</template>

<script setup>
import { ref, onMounted, watch } from 'vue';
import { Icon } from '@iconify/vue';
import SvnDatePicker from "@/components/SvnDatePicker.vue";
import { debounce } from 'lodash';

const props = defineProps({
  item: { type: Object, default: () => {} },
  data: { type: Object, default: () => {} },
})

onMounted(async() => {
  initializeModels()
})

const emit = defineEmits(['update-selected-data-filters', 'delete-filter'])

const searchText = ref(null)
const itemFound = ref(true)
const formattedData = ref(null)
const tagCategories = ref(null)
const filterOperatorOption = ref(null)
const initialData = ref([])
const formattedFilteredData = ref([])
const selectedFilterAnswerData = ref(null)

const getSelectItemsAccordingToType = (type) => {
  switch (type) {
    case "date":
      return ["before", "after"]
    case "number":
      return ["equals", "not_equal", "greater_than", "less_than"]
    default:
      return ["contains"]
  }
}

const getSelectItemText = (value) => {
  switch (value) {
    case "before":
      return "Before"
    case "after":
      return "After"
    case "equals":
      return "Equals"
    case "not_equal":
      return "Not Equal"
    case "greater_than":
      return "Greater than"
    case "less_than":
      return "Less than"
    default:
      return ""
  }
}

const getSelectItemIcon = (value) => {
  switch (value) {
    case "equals":
      return "mdi:equal"
    case "not_equal":
      return "mdi:not-equal-variant"
    case "greater_than":
      return "mdi:greater-than-or-equal"
    case "less_than":
      return "mdi:less-than-or-equal"
    default:
      return ""
  }
}

const changeSelectItemModel = (value) => {
  filterOperatorOption.value = getSelectItemText(value)
  document.getElementById('activatorMenu').click()
}

const initializeModels = () => {
  // formattedFilteredData.value = ["Tag1", "Tag2", "Tag3", "Tag4", "Tag5", "Tag6", "Tag7", "Tag8", "Tag9"]
  let tagCategoriesNames = tagCategories?.value?.map(cat => cat.name)
  if (new Set(tagCategoriesNames).has(props?.item?.key)) {
    let found = tagCategories?.value?.find(o => o.name === props?.item?.key)
    if (found) {
      for (let tag of found?.tags) {
        if (!formattedFilteredData?.value?.includes(tag)) {
          formattedFilteredData.value.push(tag?.tagName)
        }
      }
    }
  }
  else {
    formattedData.value = props?.data?.map(element => {
      return element[props?.item?.key]
    })
    for (let data of formattedData.value) {
      if (!formattedFilteredData?.value?.includes(data) && data?.length) {
        if (typeof data == "object") {
          for (let el of data) {
            formattedData.value.push(el?.title)
          }
        }
        else {
          formattedFilteredData.value.push(data)
        }
      }
    }
  }
  initialData.value = [...formattedFilteredData?.value]
  filterOperatorOption.value = getSelectItemsAccordingToType(props?.item?.type)?.[0]
}

const deleteFilter = () => {
  emit('delete-filter', selectedFilterAnswerData.value)
}

const updateSelectedFilterAnswerData = (e) => {
  emit('update-selected-data-filters', e)
}

const getFilterAnswers = () => {
  let data = ''
  selectedFilterAnswerData.value.map((element, i) => {
    if (i !== selectedFilterAnswerData?.value?.length - 1) {
      data += `${element}, `
    } else {
      data += `${element}`
    }
  })
  return data
}

const setSearch = debounce((e) => {
  if (formattedFilteredData.value.find(el => el.toLowerCase().includes(searchText.value))) {
    itemFound.value = true
  }
  else {
    itemFound.value = false
  }
}, 300)

watch(() => props?.data, (newValue, oldValue) => {
  if (newValue) {
    initializeModels()
  }
})
</script>